(function ($) {
  Drupal.libraries_load = function () {
    var libraries = "", test = 1, callback;
    if (!arguments.length) {
      return;
    }
    else {
      libraries = arguments[0];
    }
    if (arguments.length == 2) {
      callback = $.isFunction(arguments[1]) ? arguments[1] : $.noop;
      test = $.isFunction(arguments[1]) ? 1 : arguments[1];
    }
    if (arguments.length == 3) {
      test = arguments[1];
      callback = arguments[2];
    }
    $.isFunction(callback) || (callback = $.noop);
    if (!test) {
      callback();
      return;
    }
    Drupal.data_load('libraries_loader/' + libraries, function (data) {
      var behaviors = $.map(Drupal.behaviors, function (b, i) {return i;});
      var settings = {};
      var scripts = [];
      $.each(data, function (i, response) {
        switch (response.command) {
          case 'settings' :
            settings = response.settings;
            break;
          case 'add_css' :
            Drupal.settings.ajaxPageState.css[response.name] || $(response.data).prependTo('head');
            break;
          case 'add_js' :
            Drupal.settings.ajaxPageState.js[response.name] || scripts.push(response.data);
            break;
        }
      });
      Drupal.settings = $.extend(true, Drupal.settings, settings);
      var cache = $.ajaxSetup().cache;
      $.ajaxSetup({cache : true});
      $('head').append(scripts);
      $.ajaxSetup({cache : cache});
      $.each(Drupal.behaviors, function (i, b) {
        if ($.inArray(i, behaviors) < 0) {
          b.attach(document);
        }
      });
    });
    Drupal.data_load('libraries_loader/' + libraries, function () {callback()});
  }
})(jQuery);

(function ($) {
  var callbacks = {};
  Drupal.data_load = function (request) {
    var callback = $.isFunction(arguments[1]) ? arguments[1] : $.noop;
    var dataType = arguments[2] ? arguments[2] : 'JSON';
    if (!callbacks[request]) {
      callbacks[request] = $.Callbacks('memory');
      $.get(Drupal.settings.basePath + Drupal.settings.pathPrefix + request, callbacks[request].fire, dataType);
    }
    callbacks[request].add(callback);
  }
})(jQuery);